<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\EquipamentoService;

class EquipamentoController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $EquipamentoService;
   
    public function __construct($crudService, $environment, EquipamentoService $EquipamentoService) {
        parent::__construct($crudService, $environment);
        $this->EquipamentoService = $EquipamentoService;
    }
    
    public function dadosAtivos(DTO\Request $request, DTO\Response $response) {
       $response->addDataSet(new DataSet('ativos', $this->EquipamentoService->dadosAtivos()));
    }
    
    public function ativo(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        if ($method== "POST") {
          $response->addDataSet(new DataSet('resultado', [$this->EquipamentoService->insertAtivo( $request->getParameters())]));
        } else if ($method == "GET") {
           $response->addDataSet(new DataSet('detalheAtivo', $this->EquipamentoService->ativo( $request->getParameters()['NR'])));
        }
       
    }
    
    public function insumosDeManutencao(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('listaInsumos', $this->EquipamentoService->insumosDeManutencao( $request->getParameters()['NR'])));
    }
    
    public function atualizarAtivo(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('resultado', [$this->EquipamentoService->atualizarAtivo( $request->getParameters())]));
    }
    
    public function listEquipamentos(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $equipamentos = $this->EquipamentoService->listEquipamentos($params);
        $response->addDataSet(new DataSet('Equipamentos', $equipamentos));
    }
}

?>