<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class EquipamentoFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function dadosAtivos() {
      $sql = "SELECT DISTINCT FCM_EQUIPAMENTO.NREQUIPAMENTO, FCM_EQUIPAMENTO.CDEQUIPAMENTO, FCM_EQUIPAMENTO.NMEQUIPAMENTO,
                     FCM_CATEGORIAEQUIP.NMCATEGORIAEQUIP, (SELECT LISTAGG(FCM_TIPOMANUTENCAO.NMTIPOMANUTENCAO, ',') WITHIN GROUP (ORDER BY FCM_TIPOMANUTENCAO.NMTIPOMANUTENCAO)
                                                            FROM FCM_TIPOMANUTENCAO
                                                           WHERE FCM_TIPOMANUTENCAO.NRTIPOMANUTENCAO IN (SELECT FCM_RELINSUMOSEQUIP.NRRELINSUMOSEQUIP
                                                                                                           FROM FCM_RELINSUMOSEQUIP
                                                                                                          WHERE FCM_RELINSUMOSEQUIP.NREQUIPAMENTO = FCM_EQUIPAMENTO.NREQUIPAMENTO)) || ' ' as TIPOSMANUTENCAO,
                     CASE FCM_EQUIPAMENTO.IDSITUACAO WHEN '1' THEN 'Em Funcionamento' WHEN '2' THEN 'Em Manutenção' WHEN '3' THEN 'Descontinuado' END as IDSITUACAO,
                      CASE WHEN FCM_EQUIPAMENTO.DTULTATU IS NULL THEN ' ' ELSE TO_CHAR(FCM_EQUIPAMENTO.DTULTATU, 'DD/MM/YYYY') END AS DTULTATU
                FROM FCM_EQUIPAMENTO
                JOIN FCM_CATEGORIAEQUIP
                  ON FCM_EQUIPAMENTO.NRCATEGORIAEQUIP = FCM_CATEGORIAEQUIP.NRCATEGORIAEQUIP";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function ativo($nr) {
      $sql = "SELECT FCM_EQUIPAMENTO.NMEQUIPAMENTO, FCM_EQUIPAMENTO.CDEQUIPAMENTO, FCM_CATEGORIAEQUIP.NRCATEGORIAEQUIP,
                     FCM_EQUIPAMENTO.IDSITUACAO, (SELECT LISTAGG(FCM_IMGEQUIPAMENTO.DSCAMINHO,',') WITHIN GROUP (ORDER BY FCM_IMGEQUIPAMENTO.DSCAMINHO)
                                                    FROM FCM_IMGEQUIPAMENTO
                                                   WHERE FCM_IMGEQUIPAMENTO.NREQUIPAMENTO = FCM_EQUIPAMENTO.NREQUIPAMENTO) AS DSCAMINHO,
                     (SELECT LISTAGG(FCM_ESCOPOMANUT.NRESCOPOMANUT,',') WITHIN GROUP (ORDER BY FCM_ESCOPOMANUT.NRESCOPOMANUT)
                        FROM FCM_ESCOPOMANUT
                        JOIN FCM_RELACESCOPOSEQUIP
                          ON FCM_ESCOPOMANUT.NRESCOPOMANUT = FCM_RELACESCOPOSEQUIP.NRESCOPOMANUT
                       WHERE FCM_RELACESCOPOSEQUIP.NREQUIPAMENTO = FCM_EQUIPAMENTO.NREQUIPAMENTO) AS NRESCOPOMANUT                             
                FROM FCM_EQUIPAMENTO
                JOIN FCM_CATEGORIAEQUIP
                  ON FCM_EQUIPAMENTO.NRCATEGORIAEQUIP = FCM_CATEGORIAEQUIP.NRCATEGORIAEQUIP
               WHERE FCM_EQUIPAMENTO.NREQUIPAMENTO = ".$nr;

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function insumosDeManutencao($nr) {
      $sql = "SELECT FCM_EQUIPAMENTO.NREQUIPAMENTO, FCM_EQUIPAMENTO.NMEQUIPAMENTO, FCM_CATEGORIAEQUIP.NRCATEGORIAEQUIP, FCM_CATEGORIAEQUIP.NMCATEGORIAEQUIP,
                      FCM_CATEGORIAMANUT.NRCATEGORIAMANUT, FCM_CATEGORIAMANUT.NMCATEGORIAMANUT, FCM_TIPOMANUTENCAO.NRTIPOMANUTENCAO, FCM_TIPOMANUTENCAO.NMTIPOMANUTENCAO,
                      (SELECT LISTAGG(FCM_INSUMO.NRINSUMO || '|' || FCM_INSUMO.NMINSUMO || '|' || FCM_INSUMO.CDINSUMO || '|' || FCM_UNIDADEMEDIDA.NMABREVUNIDADEMEDIDA || '|' || FCM_RELINSUMOSEQUIP.QTMEDIDA, ',')
                              WITHIN GROUP (ORDER BY FCM_INSUMO.NRINSUMO)
                         FROM FCM_RELINSUMOSEQUIP
                         JOIN FCM_INSUMO
                           ON FCM_RELINSUMOSEQUIP.NRINSUMO = FCM_INSUMO.NRINSUMO
                         JOIN FCM_UNIDADEMEDIDA
                           ON FCM_INSUMO.NRUNIDADEMEDIDA = FCM_UNIDADEMEDIDA.NRUNIDADEMEDIDA
                        WHERE FCM_RELINSUMOSEQUIP.NREQUIPAMENTO = FCM_EQUIPAMENTO.NREQUIPAMENTO
                          AND FCM_RELINSUMOSEQUIP.NRTIPOMANUTENCAO = FCM_TIPOMANUTENCAO.NRTIPOMANUTENCAO
                          AND FCM_RELINSUMOSEQUIP.NRCATEGORIAMANUT = FCM_CATEGORIAMANUT.NRCATEGORIAMANUT) AS DADOS
                FROM FCM_TIPOMANUTENCAO, FCM_EQUIPAMENTO
                LEFT JOIN FCM_CATEGORIAEQUIP
                  ON FCM_EQUIPAMENTO.NRCATEGORIAEQUIP = FCM_CATEGORIAEQUIP.NRCATEGORIAEQUIP
                JOIN FCM_RELCATEGORIAEQUIPMANUT
                  ON FCM_CATEGORIAEQUIP.NRCATEGORIAEQUIP = FCM_RELCATEGORIAEQUIPMANUT.NRCATEGORIAEQUIP
                JOIN FCM_CATEGORIAMANUT
                  ON FCM_RELCATEGORIAEQUIPMANUT.NRCATEGORIAMANUT = FCM_CATEGORIAMANUT.NRCATEGORIAMANUT
               WHERE FCM_EQUIPAMENTO.NREQUIPAMENTO = ".$nr."
               ORDER BY NREQUIPAMENTO, NRCATEGORIAMANUT ASC";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function insertAtivo($param){
        $sql="INSERT INTO FCM_EQUIPAMENTO (NREQUIPAMENTO, NMEQUIPAMENTO, CDEQUIPAMENTO, NRCATEGORIAEQUIP, IDSITUACAO, NRORG, IDATIVO, DTINCLUSAO)
              VALUES (:NREQUIPAMENTO, :NMEQUIPAMENTO, :CDEQUIPAMENTO, :NRCATEGORIAEQUIP, :IDSITUACAO, :NRORG, 'S', SYSDATE)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function updateAtivo($param){
      $sql = "UPDATE FCM_EQUIPAMENTO
                SET NRCATEGORIAEQUIP = :NRCATEGORIAEQUIP,
                    IDSITUACAO = :IDSITUACAO,
                    DTULTATU = SYSDATE
                WHERE NREQUIPAMENTO = :NREQUIPAMENTO";
       
        $std = $this->connection->prepare($sql);
        
        $std->execute($param);
    }
    
    public function listEquipamentos($params) {
      $sql = "SELECT eq.NREQUIPAMENTO, eq.NMEQUIPAMENTO FROM FCM_EQUIPAMENTO eq";
      $whereClausule = $this->concatWhereClausule($params);
      $sql .= $whereClausule;
      $std = $this->connection->prepare($sql);
      if (strlen($whereClausule) > 0) {
          $std->execute($params);   
      } else {
          $std->execute();
      }
      return $std->fetchAll();
    }
    
    protected function concatWhereClausule($params) {
        $useParams = false;
        $paramKeys = array_keys($params);
        $query = "";
        foreach($paramKeys as $key) {
            if (!$useParams) {
                $useParams = true;
                $query.= " WHERE ";
            } else {
                $query.= " AND ";
            }
            $query.= "eq" . "." . $key . " = :" . $key;
        }
        return $query;
    }
}

?>