<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class FuncoesFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getPositionsFactory($params) {
        $sql = "SELECT NRPERFILACESSO, NMPERFILACESSO
                    FROM FCM_PERFILACESSO".$params;
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function positionsListFactory() {
        $sql = "SELECT NMPERFILACESSO, NRPERFILACESSO
                    FROM FCM_PERFILACESSO";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function createPositionFactory($params) {
        $sql = "INSERT INTO FCM_PERFILACESSO(NRPERFILACESSO, NMPERFILACESSO, IDPERMISSSUSUARIO,  
                                            IDPERMISSSTAREFAS, IDPERMISSSLOCAIS, IDPERMISSSCHECKLIST,
                                            IDPERMISSSRELATORIOS, IDPERMISSSGRAFICOS, IDATIVO, DTINCLUSAO,
                                            IDPERMISSSVISTORIA, IDPERMISSSCALEND, IDDIRECIONAQRCODE, IDTIPODASHBOARD)
                        VALUES (:NRPERFILACESSO, :NMPERFILACESSO, :IDPERMISSSUSUARIO,
                                            :IDPERMISSSTAREFAS, :IDPERMISSSLOCAIS, :IDPERMISSSCHECKLIST,
                                            :IDPERMISSSRELATORIOS, :IDPERMISSSGRAFICOS, :IDATIVO, SYSDATE, 
                                            :IDPERMISSSVISTORIA, :IDPERMISSSCALEND, :IDDIRECIONAQRCODE, :IDTIPODASHBOARD)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function getPositionInfoFactory($nrperfilacesso) {
        $sql = "SELECT NRPERFILACESSO, NMPERFILACESSO, IDPERMISSSUSUARIO,
                        IDPERMISSSTAREFAS, IDPERMISSSLOCAIS, IDPERMISSSCHECKLIST, IDPERMISSSRELATORIOS, 
                        IDPERMISSSGRAFICOS, IDPERMISSSVISTORIA, IDPERMISSSCALEND, IDDIRECIONAQRCODE, IDTIPODASHBOARD
                    FROM FCM_PERFILACESSO
                 WHERE NRPERFILACESSO = {$nrperfilacesso}";
            
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function updatePositionFactory($params) {
        $sql = "UPDATE FCM_PERFILACESSO
                   SET NMPERFILACESSO = :NMPERFILACESSO,
                       IDPERMISSSUSUARIO = :IDPERMISSSUSUARIO,
                       IDPERMISSSTAREFAS = :IDPERMISSSTAREFAS,
                       IDPERMISSSLOCAIS = :IDPERMISSSLOCAIS,
                       IDPERMISSSCHECKLIST = :IDPERMISSSCHECKLIST,
                       IDPERMISSSRELATORIOS = :IDPERMISSSRELATORIOS,
                       IDPERMISSSGRAFICOS = :IDPERMISSSGRAFICOS,
                       IDPERMISSSVISTORIA = :IDPERMISSSVISTORIA, 
                       IDPERMISSSCALEND = :IDPERMISSSCALEND,
                       IDDIRECIONAQRCODE = :IDDIRECIONAQRCODE,
                       IDTIPODASHBOARD = :IDTIPODASHBOARD
                 WHERE NRPERFILACESSO = :NRPERFILACESSO";
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deletePositionsFactory($params) {
        $sql = "DELETE FROM FCM_PERFILACESSO
                 WHERE NRPERFILACESSO = :NRPERFILACESSO";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function validPositionsInRelacFuncFactory($params) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_RELACFUNCPERFACESS
                 WHERE NRPERFILACESSO = :NRPERFILACESSO";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // Busca a função do usuário logago
    public function getPermissions($nrfuncionario) {
        $sql = "SELECT  A.IDPERMISSSUSUARIO,
                        A.IDPERMISSSTAREFAS, A.IDPERMISSSLOCAIS, A.IDPERMISSSCHECKLIST, 
                        A.IDPERMISSSRELATORIOS, A.IDPERMISSSGRAFICOS, A.IDPERMISSSVISTORIA,
                        A.IDPERMISSSCALEND, A.IDTIPODASHBOARD
                    FROM FCM_PERFILACESSO A
                        JOIN FCM_RELACFUNCPERFACESS B ON B.NRPERFILACESSO = A.NRPERFILACESSO
                        JOIN FCM_FUNCIONARIO C ON C.NRFUNCIONARIO = B.NRFUNCIONARIO
                 WHERE C.NRFUNCIONARIO = {$nrfuncionario}";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
        
    }
}
?>