<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class ImpactoManutFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function inserirImpacto($parametros) {

        $sql = "INSERT INTO FCM_IMPACTOMANUT(NRIMPACTOMANUT, NMIMPACTOMANUT, NRPRIORIDADEMANUTPADR, DTINCLUSAO)
                VALUES (:NRIMPACTOMANUT, :NMIMPACTOMANUT, :NRPRIORIDADEMANUTPADR, SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }
    
    public function getInformacoesImpacto() {
        
        $sql = "SELECT I.NRIMPACTOMANUT, I.NMIMPACTOMANUT, P.NMPRIORIDADEMANUT, PRI.NMPRIORIDADEMANUT AS NMPRIORIDADEPADRAO
                    FROM FCM_IMPACTOMANUT I
                    LEFT JOIN FCM_PRIORIDADEMANUT P
                    ON P.NRPRIORIDADEMANUT = I.NRPRIORIDADEMANUTPADR
                    LEFT JOIN FCM_RELPRIORIDADEIMPACTO R
                    ON R.NRIMPACTOMANUT = I.NRIMPACTOMANUT
                   LEFT JOIN FCM_PRIORIDADEMANUT PRI
                   ON PRI.NRPRIORIDADEMANUT = R.NRPRIORIDADEMANUT";
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();      
    }
    
    public function listImpactos() {
        $sql = "SELECT i.NRIMPACTOMANUT, i.NMIMPACTOMANUT 
            FROM FCM_IMPACTOMANUT i";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
}

?>