<?php
namespace FM\Service;

use FM\Factory\ListagemVistoriasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;


class ListagemVistoriasService {

    protected $connection;
    protected $ListagemVistoriasFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, ListagemVistoriasFactory $ListagemVistoriasFactory, Environment $Environment, NewCode $newCode) {
        $this->connection               = $entityManager->getConnection();
        $this->ListagemVistoriasFactory = $ListagemVistoriasFactory;
        $this->Environment              = $Environment;
        $this->newCode                  = $newCode;
    }
    // Funções da tela Lista de Tarefas
    public function getPlaceSurvey() {
        $places = $this->ListagemVistoriasFactory->getPlaceSurvey();
        return $places;
    }

    public function getEmployee($parametro) {
        $usersIds = implode(',',$parametro['usersIds']); // Transforma o array em uma string com os ids

        $employee = $this->ListagemVistoriasFactory->getEmployee($usersIds);
        return $employee;
    }

    public function getSituation() {
        $situation = $this->ListagemVistoriasFactory->getSituation();
        return $situation;
    }

    public function getCardsSurveys($parametro, $parametroIds) {
        $param = '';
        $filterPlace = 'N';
        $filterEmployee = 'N';
        $filterSituation = 'N';

        if ($parametro['selectPlace'] != '' && $parametro['selectPlace'] != null) {
            $param = $param." WHERE LC.NRLOCALCLIENTE = ".$parametro['selectPlace'];
            $filterPlace = 'S';
        }
        if ($parametro['selectEmplyoee'] != '' && $parametro['selectEmplyoee'] != null) {
            if( $filterPlace == 'N') {
                $param = $param." WHERE FUNC.NRFUNCIONARIO = ".$parametro['selectEmplyoee'];
             } else {
                $param = $param." AND FUNC.NRFUNCIONARIO = ".$parametro['selectEmplyoee'];
             }
            $filterEmployee = 'S';
        }
        if ($parametro['selectSituation'] != '' && $parametro['selectSituation'] != null) {
            if( $filterPlace == 'N' && $filterEmployee == 'N') {
                $param = $param." WHERE GCHK.IDSITUACAOGERCHK = ".$parametro['selectSituation'];
             } else {
                $param = $param." AND GCHK.IDSITUACAOGERCHK = ".$parametro['selectSituation'];
             }
            $filterSituation = 'S';
        }
        if ($parametro['TO_CHAR(GCHK.DTHORAAGEND,\'DD/MM/YYYY\')'] != '' && $parametro['TO_CHAR(GCHK.DTHORAAGEND,\'DD/MM/YYYY\')'] != null && strlen($parametro['TO_CHAR(GCHK.DTHORAAGEND,\'DD/MM/YYYY\')']) == 21) {
            if($filterPlace == 'N' && $filterEmployee == 'N' && $filterSituation == 'N' ) {
                $param = $param." WHERE TO_CHAR(GCHK.DTHORAAGEND,'DD/MM/YYYY') = ".$parametro['TO_CHAR(GCHK.DTHORAAGEND,\'DD/MM/YYYY\')'];
            } else {
                $param = $param." AND TO_CHAR(GCHK.DTHORAAGEND,'DD/MM/YYYY') = ".$parametro['TO_CHAR(GCHK.DTHORAAGEND,\'DD/MM/YYYY\')'];
            }
        }

        $usersIds = implode(',',$parametroIds); // Transforma o array em uma string com os ids

        $survey = $this->ListagemVistoriasFactory->cardsSurveys($param, $usersIds);
        return $survey;
    }

    public function getDetailsSurvey($params) {

        $parametros = array(
            "NRGERENCIAMENTOCHK"    => $params['nr'],
        );

        $details = $this->ListagemVistoriasFactory->getActivities($parametros);
        // var_dump($details);
        return $details;
    }

    // Funções da tela de Detalhes da Vistoria

    public function getTask($params) {

        $parametros = array(
            "NRATIVIDADECHK"        => $params['NRATIVIDADECHK'],
            "NRGERENCIAMENTOCHK"    => $params['NRGERENCIAMENTOCHK'],
        );

        $tasks = $this->ListagemVistoriasFactory->getTask($parametros);
        $paramReturn = array(
            "IDSITUACAOGERCHK" => $tasks[0]['IDSITUACAOGERCHK'],
            "IDSITUACAOAGEND"  => $tasks[0]['IDSITUACAOAGEND'],
            "DSOBSERVACAO"     => [],
            "CRITERIOS"        => [],
            "CRITERIOSATIVOS"  => [],
        );

        foreach ($tasks as $task) {
            $criterias       = $this->ListagemVistoriasFactory->getCriteria(array(
                "NRTAREFAGERCHK" => $task["NRTAREFAGERCHK"]
                ));
                if (!in_array($task["DSOBSTAREFAGERCHK"], $paramReturn["DSOBSERVACAO"])) {
                    $paramReturn["DSOBSERVACAO"][] =  $task["DSOBSTAREFAGERCHK"];
                }
            foreach($criterias as $criteria) {
                if (!in_array($criteria["NMCRITERIOTARGERCHK"], $paramReturn["CRITERIOS"])) {
                    $paramReturn["CRITERIOS"][] =  $criteria["NMCRITERIOTARGERCHK"];
                }
                if ($criteria["IDMARCADO"] == "S" && !in_array($criteria["NMCRITERIOTARGERCHK"], $paramReturn["CRITERIOSATIVOS"])) {
                     $paramReturn["CRITERIOSATIVOS"][] =  $criteria["NMCRITERIOTARGERCHK"];
                }
            }
        }

       $paramReturn["DSOBSERVACAO"] = implode(',', $paramReturn["DSOBSERVACAO"]);
        return $paramReturn;
    }

     public function upSurveyCriterias($id, $params) {

        $this->connection->beginTransaction();
        // debugApi([$params]);

        try {
            foreach($params as $param) {
                if (!empty($param['valuesChkbox'])){
                    $parametros = array(
                        "NRATIVIDADECHK"     => $param['NRATIVIDADECHK'],
                        "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                        "IDMARCADO"          => "N"
                    );

                    $this->ListagemVistoriasFactory->upCriterias($parametros, "");

                    $parametros["IDMARCADO"] = "S";
                    $paramQuery = " AND NMCRITERIOTARGERCHK IN(".$param['valuesChkbox'].")";

                    $this->ListagemVistoriasFactory->upCriterias($parametros, $paramQuery);

                    $parametros1 = array(
                        "NRATIVIDADECHK"     => $param['NRATIVIDADECHK'],
                        "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                        "DSOBSTAREFAGERCHK"  => $param['valueObservation']
                    );

                    $this->ListagemVistoriasFactory->upObservation($parametros1);

                    $parametros2 = array(
                        "IDSITUACAOGERCHK"   => $id,
                        "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                    );

                    $this->ListagemVistoriasFactory->upStatusSurvey($parametros2);

                } else {

                    if (empty($param['valuesChkbox'])){
                    $parametros = array(
                        "NRATIVIDADECHK"     => $param['NRATIVIDADECHK'],
                        "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                        "IDMARCADO"          => "N"
                    );

                    $this->ListagemVistoriasFactory->upCriterias($parametros, "");

                    }

                    if (empty($param['valueObservation'])){
                        $textoPadrao = "Vistoria realizada, sem não-conformidades";
                        $parametros1 = array(
                            "NRATIVIDADECHK"     => $param['NRATIVIDADECHK'],
                            "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                            "DSOBSTAREFAGERCHK"  => $textoPadrao
                        );


                        $this->ListagemVistoriasFactory->upObservation($parametros1);

                        $parametros2 = array(
                            "IDSITUACAOGERCHK"   => $id,
                            "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                        );

                        $this->ListagemVistoriasFactory->upStatusSurvey($parametros2);

                    } else {
                        $parametros1 = array(
                            "NRATIVIDADECHK"     => $param['NRATIVIDADECHK'],
                            "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                            "DSOBSTAREFAGERCHK"  => $param['valueObservation']
                        );

                        $this->ListagemVistoriasFactory->upObservation($parametros1);

                        $parametros2 = array(
                            "IDSITUACAOGERCHK"   => $id,
                            "NRGERENCIAMENTOCHK" => $param['NRGERENCIAMENTOCHK'],
                        );

                        $this->ListagemVistoriasFactory->upStatusSurvey($parametros2);
                    }

                }
            }
            $this->connection->commit();
            $response = "OK";

        } catch (\Exception $e) {
              // debugApi([$e->getMessage()]);
            $this->connection->rollback();
            $response = ($e->getMessage());
        }
        return $response;
    }
}