CREATE OR REPLACE  PROCEDURE DES_ISS_BH(
   P_CDEMPRESA      IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDINSCMUNI     IN NOTAFISCAL.CDINSCMUNI%TYPE,
   P_DTINICIAL      IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL        IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_VERSAO         VARCHAR2,
   P_CDLIVROMAG     IN VARCHAR2,
   P_NRSEQARQMAG    IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_REG_H        VARCHAR2(50);
   V_NRINSJUREMPR VARCHAR2(14);
   V_CONTADOR     NUMBER;
   V_REG_E        NUMBER;
   V_REG_S        NUMBER;
   V_CDIMPOSTO_S  VARCHAR2(2);
   V_CDIMPOSTO_E  VARCHAR2(2);
   V_VERSAO       VARCHAR2(10);
BEGIN
   V_CDIMPOSTO_S := '31';
   V_CDIMPOSTO_E := '30';
   V_CONTADOR    := 0;
   V_VERSAO      := 'VERSO300';
   SELECT REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'/',''),'-','')
     INTO V_NRINSJUREMPR
     FROM EMPRESA
    WHERE CDEMPRESA = P_CDEMPRESA;

   SELECT 'H'                                                              ||'|'||
           REPLACE(REPLACE(REPLACE(P_CDINSCMUNI,'.',''),'/',''),'-','')    ||'|'||
          V_NRINSJUREMPR                                                   ||'|'||
          V_VERSAO                                                         ||'|'
     INTO V_REG_H
     FROM DUAL;

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_CONTADOR),10,'0'), V_REG_H, P_NRSEQARQMAG);
   V_CONTADOR := V_CONTADOR + 1;
------------------------------------------------- /*REGISTRO E SERVIOS PRESTADOS*/----------------------------------------------------
   V_REG_S := 0;
   V_REG_S := DES_ISS_BH_E(P_CDEMPRESA, P_CDINSCMUNI, P_DTINICIAL, P_DTFINAL, V_VERSAO, P_NRSEQARQMAG, V_CDIMPOSTO_S, V_NRINSJUREMPR);
-------------------------------------------------/*REGISTRO R SERVIOS TOMADOS*/-------------------------------------------------------
   V_REG_E := 0;
   V_REG_E := DES_ISS_BH_R(P_CDEMPRESA, P_CDINSCMUNI, P_DTINICIAL, P_DTFINAL, V_VERSAO, P_NRSEQARQMAG, V_CDIMPOSTO_E, V_NRINSJUREMPR);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DES_ISS_BH','5.30.000'); END;
/
