/* eslint-disable */
import { Alert, AlertService, Form, Select, Textarea, TextInput } from '@zeedhi/common';
import { Http, Metadata } from '@zeedhi/core';
import { components } from '@zeedhi/vuetify';

export class ControllerNovaSolicitacaoDeServico {

  // @toDo: pegar esse valor do local storage
  public atualNrFunc = 2;
  public responsavel: string = '';

  public dataSolicitacao:string = new Date(Date.now()).toISOString();

  public preencherCategories({ component }: { component: Select }) {
    Http.get('/CategoriaManut')
      .then((response) => {
        const data = response.data.dataset.categorias[0];
        component.datasource.updateData(data);
      })
      .catch((err) => {
        AlertService.show({
          name: 'error-alert',
          timeout: 5000,
          color: 'error',
          text: err,
        });
      });
  }

  public preencherEquipamentos({ component }: { component: Select }) {
    Http.get('/Equipamentos')
      .then((response) => {
        const data = response.data.dataset.Equipamentos;
        component.datasource.updateData(data);
      })
      .catch((err) => {
        AlertService.show({
          name: 'error-alert',
          timeout: 5000,
          color: 'error',
          text: err,
        });
      });
  }
  
  public preencherResponsavel({ component }: { component: Text }) {
    Http.setBaseURL('http://robertcunha1.zeedhi.com/workfolder/fmtapp/backend/service/index.php');
    Http.get(`/Funcionarios/PerfilAcesso?NRFUNCIONARIO=${this.atualNrFunc}`)
    .then((response) => {
      const func = response.data.dataset.Funcionarios[0];
      this.responsavel = func.NMFUNCIONARIO;
      console.log(this.responsavel);
    })
    .catch((err) => {
      AlertService.show({
        name: 'error-alert',
        timeout: 5000,
        color: 'error',
        text: err,
      });
    })
  }

  public preencherImpactos({ component }: { component: Select }) {
    Http.get('/Impactos')
      .then((response) => {
        const data = response.data.dataset.Impactos;
        component.datasource.updateData(data);
      })
      .catch((err) => {
        AlertService.show({
          name: 'error-alert',
          timeout: 5000,
          color: 'error',
          text: err,
        });
      });
  }

  public criarSolicitacaoServico() {
    const form = Metadata.getInstance<Form>('formSolicitacao');
    const validate = form.validate();
    const categoria = Metadata.getInstance<Select>('selectServico').value;
    const equipamento = Metadata.getInstance<Select>('selectEquipamento').value;
    const impacto = Metadata.getInstance<Select>('selectImpacto').value;
    const descricao = Metadata.getInstance<Textarea>('textAreaDescricao').value;
    const nome = Metadata.getInstance<TextInput>('textInputNomeSolicitacao').value;

    const bodyPost = {
      NRCATEGORIAMANUT: parseInt(categoria),
      // DTSOLICITACAOSERV: currentDate,
      // @toDo: remover esse valor fixo, obter pelo local storage
      NRFUNCSOLICITANTE: 2,
      NREQUIPAMENTO: parseInt(equipamento),
      DSSOLICITACAOSERV: descricao,
      NRIMPACTOMANUT: parseInt(impacto),
      NMSOLICITACAOSERV: nome
    };

    console.log(bodyPost);
    Http.post('/SolicitacaoServ', bodyPost)
      .then((response) => {
        AlertService.show({
          name: 'success-alert',
          timeout: 5000,
          text: 'Solicitação de serviço criada com sucesso.',
          color: 'success'
        });
      })
      .catch((err) => {
        AlertService.show({
          name: 'error-alert',
          timeout: 5000,
          color: 'error',
          text: err,
        });
      });
  }
}
